var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import { css } from '@patternfly/react-styles';
import PropTypes from 'prop-types';
import styled from 'react-emotion';
import { fontFamily, fontWeight, textAlign, lineHeight, letterSpacing } from 'styled-system';
import StyledBox, { StyledBoxBase } from './StyledBox';

var StyledTextBase = styled(StyledBoxBase)(
// theme key: fonts
fontFamily,
// theme key: fontWeights
fontWeight,
// theme key: lineHeights
lineHeight,
// theme key: letterSpacings
letterSpacing,

// no theme keys
textAlign);

/**
 * StyledText inherits all the props from the StyledBox component.
 */
var StyledText = function StyledText(_ref) {
  var className = _ref.className,
      children = _ref.children,
      component = _ref.component,
      props = _objectWithoutProperties(_ref, ['className', 'children', 'component']);

  var StyledTextBaseWithComponent = StyledTextBase.withComponent(component);
  return React.createElement(
    StyledTextBaseWithComponent,
    _extends({}, props, { className: css(className) }),
    children
  );
};

StyledText.propTypes = _extends({}, StyledBox.propTypes, {

  /** font-family - Maps with Maps with StyledConstants.fonts */
  fontFamily: PropTypes.oneOfType([PropTypes.number, PropTypes.string, PropTypes.array]),
  /** font-weight - Maps with Maps with StyledConstants.fontWeights */
  fontWeight: PropTypes.oneOfType([PropTypes.number, PropTypes.string, PropTypes.array]),
  /** line-height - Maps with Maps with StyledConstants.lineHeights */
  lineHeight: PropTypes.oneOfType([PropTypes.number, PropTypes.string, PropTypes.array]),
  /** letter-spacing */
  letterSpacing: PropTypes.oneOfType([PropTypes.number, PropTypes.string, PropTypes.array]),
  /** text-align */
  textAlign: PropTypes.oneOfType([PropTypes.number, PropTypes.string, PropTypes.array])
});

StyledText.defaultProps = _extends({}, StyledBox.defaultProps, {

  fontFamily: null,
  fontWeight: null,
  lineHeight: null,
  letterSpacing: null,
  textAlign: null
});

export default StyledText;