'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactStyles = require('@patternfly/react-styles');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactEmotion = require('react-emotion');

var _reactEmotion2 = _interopRequireDefault(_reactEmotion);

var _styledSystem = require('styled-system');

var _StyledBox = require('./StyledBox');

var _StyledBox2 = _interopRequireDefault(_StyledBox);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var StyledTextBase = (0, _reactEmotion2.default)(_StyledBox.StyledBoxBase)(
// theme key: fonts
_styledSystem.fontFamily,
// theme key: fontWeights
_styledSystem.fontWeight,
// theme key: lineHeights
_styledSystem.lineHeight,
// theme key: letterSpacings
_styledSystem.letterSpacing,

// no theme keys
_styledSystem.textAlign);

/**
 * StyledText inherits all the props from the StyledBox component.
 */
var StyledText = function StyledText(_ref) {
  var className = _ref.className,
      children = _ref.children,
      component = _ref.component,
      props = _objectWithoutProperties(_ref, ['className', 'children', 'component']);

  var StyledTextBaseWithComponent = StyledTextBase.withComponent(component);
  return _react2.default.createElement(
    StyledTextBaseWithComponent,
    _extends({}, props, { className: (0, _reactStyles.css)(className) }),
    children
  );
};

StyledText.propTypes = _extends({}, _StyledBox2.default.propTypes, {

  /** font-family - Maps with Maps with StyledConstants.fonts */
  fontFamily: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string, _propTypes2.default.array]),
  /** font-weight - Maps with Maps with StyledConstants.fontWeights */
  fontWeight: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string, _propTypes2.default.array]),
  /** line-height - Maps with Maps with StyledConstants.lineHeights */
  lineHeight: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string, _propTypes2.default.array]),
  /** letter-spacing */
  letterSpacing: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string, _propTypes2.default.array]),
  /** text-align */
  textAlign: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string, _propTypes2.default.array])
});

StyledText.defaultProps = _extends({}, _StyledBox2.default.defaultProps, {

  fontFamily: null,
  fontWeight: null,
  lineHeight: null,
  letterSpacing: null,
  textAlign: null
});

exports.default = StyledText;